unit FormInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExptIntf;

type
  TFormInfo = class(TComponent)
  private
    FOnShortCut    :TNotifyEvent;
    FShortCut      :TShortCut;
    FFormSource    :String;
    procedure SetFormSource(Value :String);
  protected
    OldOnShortCut: TShortCutEvent;
    procedure FormOnShortCut(var Msg: TWMKEY; var Handled: Boolean); virtual;
  public
    constructor Create(AOwner: TComponent); Override;
    destructor  Destroy; Override;
  published
    property FormSource :String read FFormSource write SetFormSource;
    property ShortCut: TShortCut Read FShortCut Write FShortCut Default 0;
    property OnShortCut: TNotifyEvent Read FOnShortCut Write FOnShortCut;
  end;

procedure Register;

implementation
uses u_forminfo;

procedure Register;
begin
  RegisterComponents('Smart', [TFormInfo]);
end;

constructor TFormInfo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  OldOnShortCut:=tform(owner).OnShortCut;
  tform(owner).OnShortCut:=FormOnShortCut;

  if csDesigning in ComponentState then
  begin
    FFormSource:=toolservices.GetCurrentFile;
  end;
end;

destructor TFormInfo.Destroy;
begin
  inherited destroy;
end;

procedure TFormInfo.SetFormSource(Value :String);
begin
  FFormSource:=Value;
end;

procedure TFormInfo.FormOnShortCut(var Msg: TWMKEY; var Handled: Boolean);
var
  TheShortCut    :TShortCut;
  f_info         :Tf_info;
begin
  handled:=false;

  if csDesigning in ComponentState then
    exit;

{  if Msg.Msg = CN_KEYDOWN then}
  begin
    TheShortCut:=Msg.charcode;
    if GetKeyState(vk_Shift)   < 0 then Inc(TheShortCut, scShift);
    if GetKeyState(vk_Control) < 0 then Inc(TheShortCut, scCtrl);
    if GetKeyState(vk_Menu)    < 0 then Inc(TheShortCut, scAlt);

    if (FShortCut=TheShortCut) then
    begin
      handled:=true;

      f_info:=Tf_info.create(nil);
      f_info.edt_source_file.text:=FFormSource;
      f_info.showmodal;
      f_info.Free;

      if Assigned(FOnShortCut) then
        FOnShortCut(Self);

      if assigned(OldOnShortCut) then
      begin
        OldOnShortCut(Msg,Handled);
      end;
    end;
  end;
end;


end.
