unit u_forminfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls,
  SystemInfo, Gauges;

type
  Tf_info = class(TForm)
    pgc_main: TPageControl;
    pg_form: TTabSheet;
    pg_system: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    lab_computer_name: TLabel;
    lab_user_name: TLabel;
    lab_system_directory: TLabel;
    lab_windows_directory: TLabel;
    lab_platform: TLabel;
    lab_build_number: TLabel;
    lab_width: TLabel;
    lab_height: TLabel;
    btn_ok: TButton;
    SystemInfo1: TSystemInfo;
    pg_memory: TTabSheet;
    GroupBox1: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    lab_total_phys: TLabel;
    lab_avail_phys: TLabel;
    GroupBox2: TGroupBox;
    Label14: TLabel;
    Label15: TLabel;
    lab_total_page: TLabel;
    lab_avail_page: TLabel;
    RamGauge: TGauge;
    VirtualGauge: TGauge;
    edt_source_file: TEdit;
    edt_exe_name: TEdit;
    Button1: TButton;
    procedure FormActivate(Sender: TObject);
    procedure btn_okClick(Sender: TObject);

    procedure get_mem;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  f_info: Tf_info;

implementation

{$R *.DFM}

procedure Tf_info.FormActivate(Sender: TObject);
begin
  edt_exe_name.text:=application.ExeName;

  lab_width.caption:=IntToStr(GetDeviceCaps(application.mainform.Canvas.Handle, HORZRES)) + ' pixels';
  lab_height.caption:=IntToStr(GetDeviceCaps(application.mainform.Canvas.Handle, VERTRES)) + ' pixels';

  lab_computer_name.caption:=systeminfo1.ComputerName;
  lab_user_name.caption:=systeminfo1.NetworkUserName;
  lab_system_directory.caption:=systeminfo1.SystemDirectory;
  lab_windows_directory.caption:=systeminfo1.WindowsDirectory;
  lab_platform.caption:=systeminfo1.Platform;
  lab_build_number.caption:=systeminfo1.BuildNumber;

  get_mem;
end;

procedure Tf_info.btn_okClick(Sender: TObject);
begin
  close;
end;

procedure Tf_info.get_mem;
var
  MemInfo : TMemoryStatus;
begin
  MemInfo.dwLength := Sizeof (MemInfo);
  GlobalMemoryStatus (MemInfo);

  lab_total_phys.caption:=inttostr(MemInfo.dwTotalPhys div 1024) + ' K';
  lab_avail_phys.caption:=inttostr(MemInfo.dwAvailPhys div 1024) + ' K';

  lab_total_page.caption:=inttostr(MemInfo.dwTotalPageFile div 1024) + ' K';
  lab_avail_page.caption:=inttostr(MemInfo.dwAvailPageFile div 1024) + ' K';

  RamGauge.Progress := MemInfo.dwAvailPhys div
    (MemInfo.dwTotalPhys div 100);
  VirtualGauge.Progress := MemInfo.dwAvailPageFile div
    (MemInfo.dwTotalPageFile div 100);

  {if value is low, turn color to red}
  if (RamGauge.Progress < 5) then
    RamGauge.ForeColor := clRed
  else
    RamGauge.ForeColor := clLime;
  if (VirtualGauge.Progress < 20) then
    VirtualGauge.ForeColor := clRed
  else
    VirtualGauge.ForeColor := clLime;

end;

procedure Tf_info.Button1Click(Sender: TObject);
begin
  print;
end;

end.
